
/*
     ______     __                     ___     __
    /\  _  \   /\ \                   /\_ \   /\_\
    \ \ \_\ \  \ \ \      __     ___  \//\ \  \/_/_
     \ \  __ \ `/__ \   /'__`\  / __`\  \ \ \   /\ \
      \ \ \/\ \/\\_\ \_/\ \_\ \/\ \_\ \_ \_\ \_ \_\ \_
       \ \_\ \_\ \_____\ \___\ \ \______\/\____\/\____\
        \/_/\/_/\/_____/\/___L\ \/______/\/____/\/____/
                          /\____/
                          \_/__/




                  An advanced game library

                 (c) Stephane APIOU 2003


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



*/

/*! \file
 * \short definition of all adgali features
 * this file defines all adgali features
 * and must be include when you use adgali
 */


#ifndef _adgali_h
#define _adgali_h


/* Set up for C function definitions, even when using C++ */
#ifdef __cplusplus
extern "C"
{
#endif

#ifndef _AGL_PRIVATE

	typedef void *agl_handle;

#endif

/* initialization */

	extern int agl_init(agl_handle *);
	extern int agl_exit(agl_handle);

/* errors management */

#ifndef agl_assert
#define agl_assert(expr)	((void)0)
#endif

	extern char *agl_geterror(void);
	extern char *agl_getlasterror(void);

#include "agl_endian.h"
#include "agl_object.h"
#include "agl_ios.h"
#include "agl_video.h"
#include "agl_gui.h"

	extern int agl_sublayerblit(agl_handle handle, agl_pix * pix, agl_rect * srcrect, agl_rect * dstrect, agl_pos * pos);

/* Ends C function definitions when using C++ */
#ifdef __cplusplus
};
#endif

#endif /* _agl_h */
