
/*
     ______     __                     ___     __
    /\  _  \   /\ \                   /\_ \   /\_\
    \ \ \_\ \  \ \ \      __     ___  \//\ \  \/_/_
     \ \  __ \ `/__ \   /'__`\  / __`\  \ \ \   /\ \
      \ \ \/\ \/\\_\ \_/\ \_\ \/\ \_\ \_ \_\ \_ \_\ \_
       \ \_\ \_\ \_____\ \___\ \ \______\/\____\/\____\
        \/_/\/_/\/_____/\/___L\ \/______/\/____/\/____/
                          /\____/
                          \_/__/




                  An advanced game library

                 (c) Stephane APIOU 2003


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



*/

//! definition of gui's features

/*! \file
 * this file defines the grafical user interface features
 */


#ifndef _adgali_gui_h
#define _adgali_gui_h


/* Set up for C function definitions, even when using C++ */
#ifdef __cplusplus
extern "C"
{
#endif

	typedef struct
	{
		int created;	//!< if 1 this structure is filled
		agl_rect bbox;
		int yoffset;
		int advance;
	} agl_glyph;

	typedef struct _agl_font
	{
		int height;
		int ascent;
		int descent;
		int linegap;
		agl_glyph glyphs[256];	//!< the glyphs table
		struct _agl_fontio *pfio;
		void *priv;
	} agl_font;

	extern agl_font *agl_fontioload(agl_ios * ops, int size);
	extern int agl_putc(agl_pix * pix, agl_font * font, agl_pos * pos, unsigned char c);
	extern int agl_puts(agl_pix * pix, agl_font * font, agl_pos * pos, unsigned char *str);
	extern int agl_printf(agl_pix * pix, agl_font * font, agl_pos * pos, char *fmt, ...);
	extern agl_font *agl_fontnew(void);
	extern int agl_fontfree(agl_font * font);

//basedraw routines
	int agl_bdrpixcolr(agl_pix * ptr, agl_rect * rect, agl_pos * pos, unsigned long color);
	void agl_bdrhlinecolr(agl_pix * ptr, short y, short ix, short ox, unsigned long color);
	void agl_bdrvlinecolr(agl_pix * ptr, short x, short iy, short oy, unsigned long color);
	int agl_bdrlinecolr(agl_pix * ptr, agl_rect * rect, agl_pos * ipos, agl_pos * dpos, unsigned long color);

/* Ends C function definitions when using C++ */
#ifdef __cplusplus
};
#endif

#endif /* _agl_h */
